当前位置:  编程语言>python

Python异常模块traceback用法举例

 
    发布时间:2013-8-16  


    本文导语: traceback模块被用来跟踪异常返回信息. 如下例所示:import traceback try: raise SyntaxError, "traceback test" except: traceback.print_exc()将会在控制台输出类似结果:Traceback (most recent call last): File "H:\PythonWorkSpace\Test\src\TracebackTest.py", line 3,...

traceback模块被用来跟踪异常返回信息. 如下例所示:

import traceback
try:
    raise SyntaxError, "traceback test"
except:
    traceback.print_exc()

将会在控制台输出类似结果:

Traceback (most recent call last):
  File "H:PythonWorkSpaceTestsrcTracebackTest.py", line 3, in <module>
    raise SyntaxError, "traceback test"
SyntaxError: traceback test


类似在你没有捕获异常时候, 解释器所返回的结果.

你也可以传入一个文件, 把返回信息写到文件中去, 如下:

import traceback
import StringIO
try:
    raise SyntaxError, "traceback test"
except:
    fp = StringIO.StringIO()    #创建内存文件对象
    traceback.print_exc(file=fp)
    message = fp.getvalue()
    print message

这样在控制台输出的结果和上面例子一样,traceback模块还提供了extract_tb函数格式化跟踪返回信息, 得到包含错误信息的列表, 如下:


import traceback
import sys
def tracebacktest():
    raise SyntaxError, "traceback test"
try:
    tracebacktest()
except:
    info = sys.exc_info()
    for file, lineno, function, text in traceback.extract_tb(info[2]):
        print file, "line:", lineno, "in", function
        print text
    print "** %s: %s" % info[:2]


控制台输出结果如下:

H:PythonWorkSpaceTestsrcTracebackTest.py line: 7 in <module>
tracebacktest()
H:PythonWorkSpaceTestsrcTracebackTest.py line: 5 in tracebacktest
raise SyntaxError, "traceback test"
** <type 'exceptions.SyntaxError'>: traceback test


test1.py中,当分母为0的时候,调用系统退出。代码如下:


#!/usr/bin/python 
import sys
def division(a=1, b=1):
    if b==0:
         print 'b eq 0'
         sys.exit(1)
    else:
         return a/b


test2.py中,用try..except捕获异常,然后traceback.print_exc()打印

代码如下:

#!/usr/bin/python
import sys
import traceback
import test1
a=10
b=0
try:
    print test1.division(a,b)
except:
    print 'invoking division failed.'
    traceback.print_exc()
    sys.exit(1)

执行test2.py失败抛出异常。

$python test2.py
execution python-2.5.1/python (enodeb/linux)
b eq 0
invoking division failed.
Traceback (most recent call last):
  File "test2.py", line 10, in <module>
    test1.division(a,b)
  File "/home/fesu/test1.py", line 6, in division
    sys.exit(1)
SystemExit: 1




  • 本站(WWW.169IT.COM)旨在分享和传播互联网科技相关的资讯和技术,将尽最大努力为读者提供更好的信息聚合和浏览方式。
    本站(WWW.169IT.COM)站内文章除注明原创外,均为转载,整理或搜集自网络.欢迎任何形式的转载,转载请注明出处.
    转载请注明:文章转载自:[169IT-IT技术资讯]
    本文标题:Python异常模块traceback用法举例
相关文章推荐:


站内导航:


特别声明:169IT网站部分信息来自互联网,如果侵犯您的权利,请及时告知,本站将立即删除!

©2012-2019,169IT.COM,E-mail:www_169it_com#163.com(请将#改为@)

浙ICP备11055608号-3